// Code generated by protoc-gen-go-grpc. DO NOT EDIT.
// versions:
// - protoc-gen-go-grpc v1.4.0
// - protoc             (unknown)
// source: data/v0alpha/bytevault.proto

package v0alpha

import (
	context "context"
	grpc "google.golang.org/grpc"
	codes "google.golang.org/grpc/codes"
	status "google.golang.org/grpc/status"
	emptypb "google.golang.org/protobuf/types/known/emptypb"
)

// This is a compile-time assertion to ensure that this generated file
// is compatible with the grpc package it is being compiled against.
// Requires gRPC-Go v1.62.0 or later.
const _ = grpc.SupportPackageIsVersion8

const (
	ByteVaultService_Sync_FullMethodName  = "/data.v0alpha.ByteVaultService/Sync"
	ByteVaultService_Fetch_FullMethodName = "/data.v0alpha.ByteVaultService/Fetch"
)

// ByteVaultServiceClient is the client API for ByteVaultService service.
//
// For semantics around ctx use and closing/ending streaming RPCs, please refer to https://pkg.go.dev/google.golang.org/grpc/?tab=doc#ClientConn.NewStream.
//
// ByteVaultService is responsible for sending a synchronization requests,
// and fetching vault data from the data-storage service.
type ByteVaultServiceClient interface {
	// Sync synchronizes or creates byte vault with datastore. If vault does not exists yet,
	// then it will be created on the data-storage server, otherwise - if possible - this
	// vault will be synchronized with the corresponding request.
	Sync(ctx context.Context, in *SyncRequest, opts ...grpc.CallOption) (*emptypb.Empty, error)
	// Fetch fetches vault data from datastore. Every. Last. Byte.
	Fetch(ctx context.Context, in *FetchRequest, opts ...grpc.CallOption) (*FetchResponse, error)
}

type byteVaultServiceClient struct {
	cc grpc.ClientConnInterface
}

func NewByteVaultServiceClient(cc grpc.ClientConnInterface) ByteVaultServiceClient {
	return &byteVaultServiceClient{cc}
}

func (c *byteVaultServiceClient) Sync(ctx context.Context, in *SyncRequest, opts ...grpc.CallOption) (*emptypb.Empty, error) {
	cOpts := append([]grpc.CallOption{grpc.StaticMethod()}, opts...)
	out := new(emptypb.Empty)
	err := c.cc.Invoke(ctx, ByteVaultService_Sync_FullMethodName, in, out, cOpts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

func (c *byteVaultServiceClient) Fetch(ctx context.Context, in *FetchRequest, opts ...grpc.CallOption) (*FetchResponse, error) {
	cOpts := append([]grpc.CallOption{grpc.StaticMethod()}, opts...)
	out := new(FetchResponse)
	err := c.cc.Invoke(ctx, ByteVaultService_Fetch_FullMethodName, in, out, cOpts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

// ByteVaultServiceServer is the server API for ByteVaultService service.
// All implementations must embed UnimplementedByteVaultServiceServer
// for forward compatibility
//
// ByteVaultService is responsible for sending a synchronization requests,
// and fetching vault data from the data-storage service.
type ByteVaultServiceServer interface {
	// Sync synchronizes or creates byte vault with datastore. If vault does not exists yet,
	// then it will be created on the data-storage server, otherwise - if possible - this
	// vault will be synchronized with the corresponding request.
	Sync(context.Context, *SyncRequest) (*emptypb.Empty, error)
	// Fetch fetches vault data from datastore. Every. Last. Byte.
	Fetch(context.Context, *FetchRequest) (*FetchResponse, error)
	mustEmbedUnimplementedByteVaultServiceServer()
}

// UnimplementedByteVaultServiceServer must be embedded to have forward compatible implementations.
type UnimplementedByteVaultServiceServer struct {
}

func (UnimplementedByteVaultServiceServer) Sync(context.Context, *SyncRequest) (*emptypb.Empty, error) {
	return nil, status.Errorf(codes.Unimplemented, "method Sync not implemented")
}
func (UnimplementedByteVaultServiceServer) Fetch(context.Context, *FetchRequest) (*FetchResponse, error) {
	return nil, status.Errorf(codes.Unimplemented, "method Fetch not implemented")
}
func (UnimplementedByteVaultServiceServer) mustEmbedUnimplementedByteVaultServiceServer() {}

// UnsafeByteVaultServiceServer may be embedded to opt out of forward compatibility for this service.
// Use of this interface is not recommended, as added methods to ByteVaultServiceServer will
// result in compilation errors.
type UnsafeByteVaultServiceServer interface {
	mustEmbedUnimplementedByteVaultServiceServer()
}

func RegisterByteVaultServiceServer(s grpc.ServiceRegistrar, srv ByteVaultServiceServer) {
	s.RegisterService(&ByteVaultService_ServiceDesc, srv)
}

func _ByteVaultService_Sync_Handler(srv interface{}, ctx context.Context, dec func(interface{}) error, interceptor grpc.UnaryServerInterceptor) (interface{}, error) {
	in := new(SyncRequest)
	if err := dec(in); err != nil {
		return nil, err
	}
	if interceptor == nil {
		return srv.(ByteVaultServiceServer).Sync(ctx, in)
	}
	info := &grpc.UnaryServerInfo{
		Server:     srv,
		FullMethod: ByteVaultService_Sync_FullMethodName,
	}
	handler := func(ctx context.Context, req interface{}) (interface{}, error) {
		return srv.(ByteVaultServiceServer).Sync(ctx, req.(*SyncRequest))
	}
	return interceptor(ctx, in, info, handler)
}

func _ByteVaultService_Fetch_Handler(srv interface{}, ctx context.Context, dec func(interface{}) error, interceptor grpc.UnaryServerInterceptor) (interface{}, error) {
	in := new(FetchRequest)
	if err := dec(in); err != nil {
		return nil, err
	}
	if interceptor == nil {
		return srv.(ByteVaultServiceServer).Fetch(ctx, in)
	}
	info := &grpc.UnaryServerInfo{
		Server:     srv,
		FullMethod: ByteVaultService_Fetch_FullMethodName,
	}
	handler := func(ctx context.Context, req interface{}) (interface{}, error) {
		return srv.(ByteVaultServiceServer).Fetch(ctx, req.(*FetchRequest))
	}
	return interceptor(ctx, in, info, handler)
}

// ByteVaultService_ServiceDesc is the grpc.ServiceDesc for ByteVaultService service.
// It's only intended for direct use with grpc.RegisterService,
// and not to be introspected or modified (even as a copy)
var ByteVaultService_ServiceDesc = grpc.ServiceDesc{
	ServiceName: "data.v0alpha.ByteVaultService",
	HandlerType: (*ByteVaultServiceServer)(nil),
	Methods: []grpc.MethodDesc{
		{
			MethodName: "Sync",
			Handler:    _ByteVaultService_Sync_Handler,
		},
		{
			MethodName: "Fetch",
			Handler:    _ByteVaultService_Fetch_Handler,
		},
	},
	Streams:  []grpc.StreamDesc{},
	Metadata: "data/v0alpha/bytevault.proto",
}
